Index: src/libcfa/iostream
===================================================================
--- src/libcfa/iostream	(revision 4b8f918cba0878620f93c5453ef29a5abc15547a)
+++ src/libcfa/iostream	(revision 3849857090acdc78a64258d90266372878107e93)
@@ -10,6 +10,6 @@
 // Created On       : Wed May 27 17:56:53 2015
 // Last Modified By : Peter A. Buhr
-// Last Modified On : Tue Apr  5 22:32:37 2016
-// Update Count     : 90
+// Last Modified On : Sun Apr 10 23:00:12 2016
+// Update Count     : 92
 //
 
@@ -20,13 +20,14 @@
 
 trait ostream( dtype ostype ) {
-	_Bool sepPrt( ostype * );
-	void sepOn( ostype * );
-	void sepOff( ostype * );
-	void sepReset( ostype * );
-	void sepReset( ostype *, _Bool );
-	void sepSet( ostype *, const char * );
-	const char * sepGet( ostype * );
-	_Bool sepDisable( ostype * );
-	_Bool sepEnable( ostype * );
+	_Bool sepPrt( ostype * );							// return separator state (on/off)
+	void sepOn( ostype * );								// turn separator state on
+	void sepOff( ostype * );							// turn separator state off
+	void sepReset( ostype * );							// set separator state to default state
+	void sepReset( ostype *, _Bool );					// set separator and default state
+	void sepSet( ostype *, const char * );				// set separator to string (15 character maximum)
+	const char * sepGet( ostype * );					// get separator string 
+	_Bool sepDisable( ostype * );						// set default state to off, and return previous state
+	_Bool sepEnable( ostype * );						// set default state to on, and return previous state
+
 	int fail( ostype * );
 	int flush( ostype * );
Index: src/libcfa/stdlib
===================================================================
--- src/libcfa/stdlib	(revision 4b8f918cba0878620f93c5453ef29a5abc15547a)
+++ src/libcfa/stdlib	(revision 3849857090acdc78a64258d90266372878107e93)
@@ -10,6 +10,6 @@
 // Created On       : Thu Jan 28 17:12:35 2016
 // Last Modified By : Peter A. Buhr
-// Last Modified On : Fri Apr  1 22:26:14 2016
-// Update Count     : 73
+// Last Modified On : Tue Apr 12 18:22:54 2016
+// Update Count     : 77
 //
 
@@ -22,4 +22,8 @@
 
 forall( otype T ) T * malloc( void );
+extern "C" {
+void * malloc( size_t );								// use default C for void *
+} // extern "C"
+forall( otype T ) T * malloc( size_t size );
 forall( otype T ) T * malloc( char fill );
 forall( otype T ) T * malloc( T * ptr, size_t size );
Index: src/libcfa/stdlib.c
===================================================================
--- src/libcfa/stdlib.c	(revision 4b8f918cba0878620f93c5453ef29a5abc15547a)
+++ src/libcfa/stdlib.c	(revision 3849857090acdc78a64258d90266372878107e93)
@@ -10,6 +10,6 @@
 // Created On       : Thu Jan 28 17:10:29 2016
 // Last Modified By : Peter A. Buhr
-// Last Modified On : Wed Mar 30 10:48:41 2016
-// Update Count     : 149
+// Last Modified On : Tue Apr 12 18:19:22 2016
+// Update Count     : 151
 //
 
@@ -28,13 +28,13 @@
 
 forall( otype T ) T * malloc( void ) {
-	printf( "malloc1\n" );
+	//printf( "malloc1\n" );
     return (T *)malloc( sizeof(T) );
 } // malloc
 forall( otype T ) T * malloc( size_t size ) {
-	printf( "malloc2\n" );
+	//printf( "malloc2\n" );
     return (T *)(void *)malloc( size );
 } // malloc
 forall( otype T ) T * malloc( char fill ) {
-	printf( "malloc3\n" );
+	//printf( "malloc3\n" );
 	T * ptr = (T *)malloc( sizeof(T) );
     return memset( ptr );
@@ -42,14 +42,14 @@
 
 forall( otype T ) T * calloc( size_t size ) {
-	printf( "calloc\n" );
+	//printf( "calloc\n" );
     return (T *)calloc( size, sizeof(T) );
 } // calloc
 
 forall( otype T ) T * realloc( T * ptr, size_t size ) {
-	printf( "realloc1\n" );
+	//printf( "realloc1\n" );
     return (T *)(void *)realloc( (void *)ptr, size );
 } // realloc
 forall( otype T ) T * realloc( T * ptr, size_t size, unsigned char fill ) {
-	printf( "realloc2\n" );
+	//printf( "realloc2\n" );
     char * nptr = (T *)(void *)realloc( (void *)ptr, size );
     size_t unused = malloc_usable_size( nptr );
@@ -59,33 +59,33 @@
 
 forall( otype T ) T * malloc( T * ptr, size_t size ) {
-	printf( "malloc4\n" );
+	//printf( "malloc4\n" );
     return (T *)realloc( ptr, size );
 } // malloc
 forall( otype T ) T * malloc( T * ptr, size_t size, unsigned char fill ) {
-	printf( "malloc5\n" );
+	//printf( "malloc5\n" );
     return (T *)realloc( ptr, size, fill );
 } // malloc
 
 forall( otype T ) T * aligned_alloc( size_t alignment ) {
-	printf( "aligned_alloc\n" );
+	//printf( "aligned_alloc\n" );
     return (T *)memalign( alignment, sizeof(T) );
 } // aligned_alloc
 
 forall( otype T ) T * memalign( size_t alignment ) {
-	printf( "memalign\n" );
+	//printf( "memalign\n" );
     return (T *)memalign( alignment, sizeof(T) );
 } // memalign
 
 forall( otype T ) int posix_memalign( T ** ptr, size_t alignment ) {
-	printf( "posix_memalign\n" );
+	//printf( "posix_memalign\n" );
     return posix_memalign( (void **)ptr, alignment, sizeof(T) );
 } // posix_memalign
 
 forall( otype T ) T * memset( T * ptr, unsigned char fill ) { // use default value '\0' for fill
-	printf( "memset1\n" );
+	//printf( "memset1\n" );
     return (T *)memset( ptr, (int)fill, malloc_usable_size( ptr ) );
 } // memset
 forall( otype T ) T * memset( T * ptr ) {				// remove when default value available
-	printf( "memset2\n" );
+	//printf( "memset2\n" );
     return (T *)memset( ptr, 0, malloc_usable_size( ptr ) );
 } // memset